#!/usr/bin/perl
use strict;

my $freq = 1.2;  # modifies the sine wave frequency
my $offset = 0.666667;	# modifies the perceived center for each possible phase
my $samples = 8;

print "\n// freq:".$freq." offset:".$offset."\n";
for( my $pixelPhase=0; $pixelPhase<=2; $pixelPhase++ ) {
	my @out;
	my $total = 0;
	my $center = ($samples-1)/2;
	
	for( my $i=0; $i<$samples; $i++ ) {
		# 16 samples totol => 0..15
		my $x;
		if( $pixelPhase == 0 ) {
			# Phase 0: center is at ~5.5 - 2/3
			$x = ($i-($center - $offset)) * $freq;
		} elsif( $pixelPhase == 1 ) {
			# Phase 1: center is at 5.5 
			$x = ($i-$center) * $freq;
		} else {
			# Phase 2: center is at ~5.5 + 2/3
			$x = ($i-($center + $offset)) * $freq;
		}
		
		# FILTER
		my $var = sin($x) / $x;  # sinc

		$total += $var;
		push( @out, $var );
	}
	
	# debuggening teh sheeyat
	if( 0 ) {
		print "Total is $total\n";
		print "Now to create some Pixel Bender code...\n";
		print ("-" x 60);
		print "\n";
	}

	my $count=0;
	my @four;
	my $posChars="ABCD";
	while( my $var = shift @out ) {
		# Print the values as groups of float4's
		push(@four, ($var/$total));
		if( $count % 4 == 3 ) {
			my $join = @four.join(',' , @four);
			#print $join . "\n";	# has an extra character at the front?! wtf larry wall
			$join = substr($join, 1, 999);
			print "const float4 SINC_".$pixelPhase.substr($posChars,($count-3)/4,1) . " = float4(".$join.");\n";
  			delete @four[0 .. $#four];	# empty array
		}
		$count++;
	}
	
	print "\n";
}